package graph
import (
    "strings"
    "errors"
)
// Provides operations to manage the deviceManagement singleton.
type IosUpdatesInstallStatus int

const (
    DEVICEOSHIGHERTHANDESIREDOSVERSION_IOSUPDATESINSTALLSTATUS IosUpdatesInstallStatus = iota
    SHAREDDEVICEUSERLOGGEDINERROR_IOSUPDATESINSTALLSTATUS
    NOTSUPPORTEDOPERATION_IOSUPDATESINSTALLSTATUS
    INSTALLFAILED_IOSUPDATESINSTALLSTATUS
    INSTALLPHONECALLINPROGRESS_IOSUPDATESINSTALLSTATUS
    INSTALLINSUFFICIENTPOWER_IOSUPDATESINSTALLSTATUS
    INSTALLINSUFFICIENTSPACE_IOSUPDATESINSTALLSTATUS
    INSTALLING_IOSUPDATESINSTALLSTATUS
    DOWNLOADINSUFFICIENTNETWORK_IOSUPDATESINSTALLSTATUS
    DOWNLOADINSUFFICIENTPOWER_IOSUPDATESINSTALLSTATUS
    DOWNLOADINSUFFICIENTSPACE_IOSUPDATESINSTALLSTATUS
    DOWNLOADREQUIRESCOMPUTER_IOSUPDATESINSTALLSTATUS
    DOWNLOADFAILED_IOSUPDATESINSTALLSTATUS
    DOWNLOADING_IOSUPDATESINSTALLSTATUS
    SUCCESS_IOSUPDATESINSTALLSTATUS
    AVAILABLE_IOSUPDATESINSTALLSTATUS
    IDLE_IOSUPDATESINSTALLSTATUS
    UNKNOWN_IOSUPDATESINSTALLSTATUS
)

func (i IosUpdatesInstallStatus) String() string {
    return []string{"DEVICEOSHIGHERTHANDESIREDOSVERSION", "SHAREDDEVICEUSERLOGGEDINERROR", "NOTSUPPORTEDOPERATION", "INSTALLFAILED", "INSTALLPHONECALLINPROGRESS", "INSTALLINSUFFICIENTPOWER", "INSTALLINSUFFICIENTSPACE", "INSTALLING", "DOWNLOADINSUFFICIENTNETWORK", "DOWNLOADINSUFFICIENTPOWER", "DOWNLOADINSUFFICIENTSPACE", "DOWNLOADREQUIRESCOMPUTER", "DOWNLOADFAILED", "DOWNLOADING", "SUCCESS", "AVAILABLE", "IDLE", "UNKNOWN"}[i]
}
func ParseIosUpdatesInstallStatus(v string) (interface{}, error) {
    result := DEVICEOSHIGHERTHANDESIREDOSVERSION_IOSUPDATESINSTALLSTATUS
    switch strings.ToUpper(v) {
        case "DEVICEOSHIGHERTHANDESIREDOSVERSION":
            result = DEVICEOSHIGHERTHANDESIREDOSVERSION_IOSUPDATESINSTALLSTATUS
        case "SHAREDDEVICEUSERLOGGEDINERROR":
            result = SHAREDDEVICEUSERLOGGEDINERROR_IOSUPDATESINSTALLSTATUS
        case "NOTSUPPORTEDOPERATION":
            result = NOTSUPPORTEDOPERATION_IOSUPDATESINSTALLSTATUS
        case "INSTALLFAILED":
            result = INSTALLFAILED_IOSUPDATESINSTALLSTATUS
        case "INSTALLPHONECALLINPROGRESS":
            result = INSTALLPHONECALLINPROGRESS_IOSUPDATESINSTALLSTATUS
        case "INSTALLINSUFFICIENTPOWER":
            result = INSTALLINSUFFICIENTPOWER_IOSUPDATESINSTALLSTATUS
        case "INSTALLINSUFFICIENTSPACE":
            result = INSTALLINSUFFICIENTSPACE_IOSUPDATESINSTALLSTATUS
        case "INSTALLING":
            result = INSTALLING_IOSUPDATESINSTALLSTATUS
        case "DOWNLOADINSUFFICIENTNETWORK":
            result = DOWNLOADINSUFFICIENTNETWORK_IOSUPDATESINSTALLSTATUS
        case "DOWNLOADINSUFFICIENTPOWER":
            result = DOWNLOADINSUFFICIENTPOWER_IOSUPDATESINSTALLSTATUS
        case "DOWNLOADINSUFFICIENTSPACE":
            result = DOWNLOADINSUFFICIENTSPACE_IOSUPDATESINSTALLSTATUS
        case "DOWNLOADREQUIRESCOMPUTER":
            result = DOWNLOADREQUIRESCOMPUTER_IOSUPDATESINSTALLSTATUS
        case "DOWNLOADFAILED":
            result = DOWNLOADFAILED_IOSUPDATESINSTALLSTATUS
        case "DOWNLOADING":
            result = DOWNLOADING_IOSUPDATESINSTALLSTATUS
        case "SUCCESS":
            result = SUCCESS_IOSUPDATESINSTALLSTATUS
        case "AVAILABLE":
            result = AVAILABLE_IOSUPDATESINSTALLSTATUS
        case "IDLE":
            result = IDLE_IOSUPDATESINSTALLSTATUS
        case "UNKNOWN":
            result = UNKNOWN_IOSUPDATESINSTALLSTATUS
        default:
            return 0, errors.New("Unknown IosUpdatesInstallStatus value: " + v)
    }
    return &result, nil
}
func SerializeIosUpdatesInstallStatus(values []IosUpdatesInstallStatus) []string {
    result := make([]string, len(values))
    for i, v := range values {
        result[i] = v.String()
    }
    return result
}
